//+------------------------------------------------------------------+
//|                                                     MAAligned.mq4 |
//|                                      Copyright 2018, Nick Hariri |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, Nick Hariri"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 clrGreen
#property indicator_color2 clrRed
#property indicator_width1 1
#property indicator_width2 1
//--- input parameters

double up[];
double down[];
datetime candletime=0;
datetime currenttime=0;
extern int Direction=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {

//--- indicator buffers mapping
   SetIndexBuffer(0,up);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,142);
   SetIndexLabel(0,"Up Arrow");
   SetIndexBuffer(1,down);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,142);
   SetIndexLabel(1,"Down Arrow");
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {

currenttime=Time[0];
int limit = MathMax(rates_total-prev_calculated,2);
for(int i=1;i<limit;i++)
{


//Up Trend Signal

 if(!CheckIfBullish(i))

   {
   up[i]=Low[i]-0.0005;
   
   if(Direction != 1) 
   Direction = 1;
   if(currenttime!=candletime && i==1)
      {
      Alert((string)Period()+"M ",Symbol()," "+" Just made a Bullish Top25 Bar!");
      SendNotification((string)Period()+"M "+Symbol()+" "+" Just made a Bullish Top25 Bar!");
      }
      ObjectCreate(_Symbol,"PinBarValue",OBJ_LABEL,0,TimeCurrent(),up[i]);
      ObjectSetText("PinBarValue",iLowest(NULL,0,MODE_LOW,24,i),8,"Tahoma",Red);
      
   candletime=Time[0];
   }
   

// Down Trend Signal
   
    if(!CheckIfBearish(i))
      
   {
   down[i]=High[i]+0.0005;
   
   if(Direction != -1) 
   Direction = -1;
      if(currenttime!=candletime && i==1)
      {
      Alert((string)Period()+"M ",Symbol()," "+" Just made a Bearish Top25Bar!");
      SendNotification((string)Period()+"M "+Symbol()+" "+" Just made a Bullish Top25 Bar!");
      }
   candletime=Time[0];
   }
   

}


//--- return value of prev_calculated for next call
   return(rates_total);
  }


//+------------------------------------------------------------------+
//| CheckIfBullish                                      |
//+------------------------------------------------------------------+
bool CheckIfBullish(const int x)
{
      //Are the MA's aligned
      {
      if(!iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x)>iMA(0,15,18,0,MODE_EMA,PRICE_CLOSE,x) 
      && !iMA(0,15,18,0,MODE_EMA,PRICE_CLOSE,x)>iMA(0,15,50,0,MODE_EMA,PRICE_CLOSE,x) 
      && !iMA(0,15,50,0,MODE_EMA,PRICE_CLOSE,x)>iMA(0,15,200,0,MODE_SMA,PRICE_CLOSE,x)
      && !iMA(0,60,6,0,MODE_EMA,PRICE_CLOSE,x)>iMA(0,60,18,0,MODE_EMA,PRICE_CLOSE,x)
      && !iMA(0,60,18,0,MODE_EMA,PRICE_CLOSE,x)>iMA(0,60,50,0,MODE_EMA,PRICE_CLOSE,x)
      && !iMA(0,60,50,0,MODE_EMA,PRICE_CLOSE,x)>iMA(0,60,200,0,MODE_SMA,PRICE_CLOSE,x))
      
      }
      {
      //Must be 3 higher highs
      if(High[x+1]>High[x+2] && High[x+2]>High[x+3])
      
      }
      {
      //Min 1 Candle wick must touch the 6EMA               
      if(Low[2]<=iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x+1)    
         || Low[3]<=iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x+2) 
         || Low[4]<=iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x+3))
      
      }
      {  
      //Min 1 candle has to be bigger than the 14 day ATR   
      if(High[x+1]-Low[x+1]>=iATR(0,15,14,x+2)                 
         || High[x+2]-Low[x+2]>=iATR(0,15,14,x+3) 
         || High[x+3]-Low[x+3]>=iATR(0,15,14,x+4))
      
      }
      {           
      //No wicks must touch the 18EMA   
      if(Low[x+1]>iMA(0,15,18,0,MODE_EMA,PRICE_CLOSE,x+1)    
         || Low[x+2]>iMA(0,15,18,0,MODE_EMA,PRICE_CLOSE,x+2)
         || Low[x+3]>iMA(0,15,18,0,MODE_EMA,PRICE_CLOSE,x+3))
      
      }
      {
      //No Close below the 6EMA
      if(Close[x+1]>iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x+1)   
      && Close[x+2]>iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x+2)
      && Close[x+3]>iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x+3)
      //Swing High Candle must be Bullish
      && Open[x+1]>Close[x+1])                            
      return(true);
      }

return(false);
}


//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| CheckIfBearish                                    |
//+------------------------------------------------------------------+
int CheckIfBearish(const int x)
{
      //Are the MA's aligned
      {
      if(iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x)<iMA(0,15,18,0,MODE_EMA,PRICE_CLOSE,x) 
      && iMA(0,15,18,0,MODE_EMA,PRICE_CLOSE,x)<iMA(0,15,50,0,MODE_EMA,PRICE_CLOSE,x) 
      && iMA(0,15,50,0,MODE_EMA,PRICE_CLOSE,x)<iMA(0,15,200,0,MODE_SMA,PRICE_CLOSE,x)
      && iMA(0,60,6,0,MODE_EMA,PRICE_CLOSE,x)<iMA(0,60,18,0,MODE_EMA,PRICE_CLOSE,x)
      && iMA(0,60,18,0,MODE_EMA,PRICE_CLOSE,x)<iMA(0,60,50,0,MODE_EMA,PRICE_CLOSE,x)
      && iMA(0,60,50,0,MODE_EMA,PRICE_CLOSE,x)<iMA(0,60,200,0,MODE_SMA,PRICE_CLOSE,x))
{
}
      //Must be 3 Lower Lows
      &&(Low[x+1]<Low[x+2] && Low[x+2]<Low[x+3]) 

      //Min 1 Candle wick must touch the 6EMA
      if(High[x+1]>=iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x+1)   
         || High[x+2]>=iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x+2) 
         || High[x+3]>=iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x+3))


      //Min 1 candle has to be bigger than the 14 day ATR
      if(High[x+1]-Low[x+1]>=iATR(0,15,14,x+2)                 
         && High[x+2]-Low[x+2]>=iATR(0,15,14,x+3) 
         && High[x+3]-Low[x+3]>=iATR(0,15,14,x+4))

   
      //No wicks must touch the 18EMA   
      if(Low[x+1]>iMA(0,15,18,0,MODE_EMA,PRICE_CLOSE,x+1)    
         || Low[x+2]>iMA(0,15,18,0,MODE_EMA,PRICE_CLOSE,x+2)
         || Low[x+3]>iMA(0,15,18,0,MODE_EMA,PRICE_CLOSE,x+3))
      
     
      }
      {   
      //No Close above the 6EMA   
      if(Close[x+1]<iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x+1)   
      && Close[x+2]<iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x+2)
      && Close[x+3]<iMA(0,15,6,0,MODE_EMA,PRICE_CLOSE,x+3)
      //Swing High Candle must be Bearish
      && Open[x+1]<Close[x+1])                             
      return(true);
      }
return(false);
}


//+------------------------------------------------------------------+